package registry

//EntryBatch helper to batch set properties
type EntryBatch []*Entry

// Batch returns a batch of entries for easy manipulation
func Batch(params ...interface{}) EntryBatch {
	ret := EntryBatch{}
	for _, el := range params {
		switch v := el.(type) {
		case EntryBatch:
			ret = append(ret, v...)
		case *Entry:
			ret = append(ret, v)
		}
	}
	return ret
}

//Tags set categories of the group
func (eg EntryBatch) Tags(cat ...string) EntryBatch {
	for _, e := range eg {
		e.Tags(cat...)
	}
	return eg
}

// DescInputs describe inputs
func (eg EntryBatch) DescInputs(input ...string) EntryBatch {
	for _, e := range eg {
		e.DescInputs(input...)
	}
	return eg

}

// DescOutput describe inputs
func (eg EntryBatch) DescOutput(v string) EntryBatch {
	for _, e := range eg {
		e.DescOutput(v)
	}
	return eg
}

// Extra set extras of the group
func (eg EntryBatch) Extra(name string, value interface{}) EntryBatch {
	for _, e := range eg {
		e.Extra(name, value)
	}
	return eg
}
